/// <reference types="react" />
import { JSONSchema6 } from 'json-schema';
import { DataTypeEditProps } from '../Filters';
import { SelectProps } from '../Select';
export declare const operators: {
    is: {
        getLabel: (_s: JSONSchema6) => string;
    };
    is_not: {
        getLabel: (_s: JSONSchema6) => string;
    };
};
declare type OperatorSlug = keyof typeof operators;
interface OneOfFilter extends JSONSchema6 {
    title: OperatorSlug;
    properties?: {
        [k: string]: {
            const?: any;
            not?: {
                const?: any;
            };
        };
    };
}
interface DecodeFilterResult {
    field: string;
    operator: OperatorSlug;
    value: any;
}
export declare const decodeFilter: (filter: OneOfFilter) => DecodeFilterResult | null;
export declare const createFilter: (field: string, operator: "is" | "is_not", value: any, schema: JSONSchema6) => OneOfFilter;
interface OneOf {
    const: string | boolean | number;
    title: string;
}
export declare const Edit: ({ schema, value, onUpdate, ...props }: DataTypeEditProps & SelectProps<OneOf>) => JSX.Element;
export {};
