import * as React from 'react';
import { RenditionSystemProps } from '../common-types';
import { ButtonProps } from './Button';
interface DropDownButtonState {
    open: boolean;
    minWidth: number;
}
declare class DropDownButton extends React.Component<InternalDropDownButtonProps, DropDownButtonState> {
    dropdownNode: HTMLDivElement | null;
    constructor(props: InternalDropDownButtonProps);
    componentWillUnmount(): void;
    handleOutsideClick: (e: MouseEvent) => void;
    toggle: () => void;
    removeListener: () => void;
    render(): JSX.Element;
}
export interface InternalDropDownButtonProps extends ButtonProps {
    label?: string | JSX.Element;
    border?: boolean;
    joined?: boolean;
    alignRight?: boolean;
    noListFormat?: boolean;
    maxHeight?: string | number;
}
export declare type DropDownButtonProps = InternalDropDownButtonProps & RenditionSystemProps;
declare const _default: React.ForwardRefExoticComponent<InternalDropDownButtonProps & import("../common-types").Tooltip & import("../common-types").StyledSystemProps & React.RefAttributes<DropDownButton>>;
export default _default;
