"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var marked_1 = __importDefault(require("marked"));
var sanitize_html_1 = __importDefault(require("sanitize-html"));
var renderer = new marked_1.default.Renderer();
renderer.link = function (_href, _title, _text) {
    var link = marked_1.default.Renderer.prototype.link.apply(this, arguments);
    return link.replace('<a', '<a target="_blank" rel="noopener noreferrer"');
};
var markedOptions = {
    gfm: true,
    breaks: true,
    headerIds: false,
    sanitize: false,
    renderer: renderer,
};
var sanitizerOptions = {
    allowedTags: sanitize_html_1.default.defaults.allowedTags.concat([
        'del',
        'h1',
        'h2',
        'img',
        'input',
    ]),
    allowedAttributes: {
        a: ['href', 'name', 'target', 'rel'],
        img: ['src'],
        input: [
            {
                name: 'type',
                multiple: false,
                values: ['checkbox'],
            },
            'disabled',
            'checked',
        ],
        span: ['class'],
    },
};
exports.parseMarkdown = function (text) {
    if (text === void 0) { text = ''; }
    var html = marked_1.default(text, markedOptions);
    var clean = sanitize_html_1.default(html, sanitizerOptions);
    return clean;
};
